<?php declare(strict_types=1);

namespace June\Migration;

use Doctrine\DBAL\Connection;
use Shopware\Core\Framework\Migration\MigrationStep;

class Migration1719931681JuneCustomerExtension extends MigrationStep
{
    public function getCreationTimestamp(): int
    {
        return 1719931681;
    }

    public function update(Connection $connection): void
    {
        $sql = <<<SQL
CREATE TABLE IF NOT EXISTS `june_customer_extension` (
    `id` BINARY(16) NOT NULL,
    `customer_id` BINARY(16) NULL,
    `june_id` VARCHAR(24) NULL,
    `created_at` DATETIME(3) NOT NULL,
    `updated_at` DATETIME(3) NULL,
    PRIMARY KEY (`id`),
    KEY `fk.june_customer_extension.customer_id` (`customer_id`),
    CONSTRAINT `fk.june_customer_extension.customer_id` FOREIGN KEY (`customer_id`) REFERENCES `customer` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
SQL;
        $connection->executeStatement($sql);
    }

    public function updateDestructive(Connection $connection): void
    {
        // implement update destructive
    }
}
