import template from './june-modal.html.twig';
import './june-modal.scss'
const { Component, Mixin, Context } = Shopware;
const Criteria = Shopware.Data.Criteria;

Component.register('june-modal-select', {
    template,

    props: {
        sequence: {
            type: Object,
            required: true,
        },
    },

    mixins: [
        Mixin.getByName('notification'),
    ],

    inject: ['repositoryFactory'],

    data() {
        return {
            juneFlowAction: null,
            newCollectToken: null,
            isLoading: null
        };
    },

    computed: {
        actionRepository() {
            return this.repositoryFactory.create('juneflowaction');
        },
    },

    created() {
        this.createdComponent();

        this.newCollectToken = this.actionRepository.create(Shopware.Context.api);
    },

    methods: {
        createdComponent() {
            this.juneFlowAction = this.sequence?.config?.juneFlowAction || null;

            this.isLoading = false;
        },

        onClose() {
            this.$emit('modal-close');
        },

        onAddAction() {

            if(this.juneFlowAction === null) {
                this.createNotificationError({
                    message: "You need to select a Collect Token"
                });
                this.$emit('modal-close');
            }

            let sequence = {
                ...this.sequence,
                config: {
                    ...this.config,
                    juneFlowAction: this.juneFlowAction,
                },
            };

            this.$emit('process-finish', sequence);
        },
    },
});
