import template from './june-cms-element-june-page.html.twig';
import './june-cms-element-june-page.scss';

const { Component, Mixin, Context } = Shopware;
const Criteria = Shopware.Data.Criteria;

Shopware.Component.register('june-cms-el-june-page', {
    template,

    inject: ['repositoryFactory'],

    mixins: [
        Mixin.getByName('cms-element')
    ],

    created() {
        this.createdComponent();
    },

    data() {
        return {
            sitemapnodename: "No JUNE Page Selected",
            html: 'null',
            css: 'null',
            js: 'null'
        }
    },

    computed: {
        repository() {
            return this.repositoryFactory.create('junepage');
        },

        selectedJunePage() {
            return this.element.config.junePage.value;
        }
    },

    methods: {
        createdComponent() {
            this.initElementConfig('june-page-select');
            this.initElementData('june-page-select');

            if (this.element.config.junePage.value) {
                this.getEntityProperties();
            }
        },

        getEntityProperties() {
            if (this.element.config.junePage.value) {
                const criteria = new Criteria();

                this.repository
                    .get(this.element.config.junePage.value, Context.api, criteria)
                    .then((entity) => {
                        this.id = entity.id
                        this.sitemapid = entity.sitemapid;
                        this.sitemapnodename = entity.sitemapnodename;
                        this.sitemapnodeid = entity.sitemapnodeid;
                        this.html = entity.html;
                        this.css = entity.css;
                        this.js = entity.js;
                    });
            } else {
                this.sitemapid = '1010101';
                this.sitemapnodename = 'No JUNE Page Selected';
                this.sitemapnodeid = 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque faucibus maximus velit, dictum mollis erat finibus quis. Ut dictum ornare dolor, sed mattis tellus gravida vel.';
                this.html = '<div><p>Demo Text</p></div>';
                this.css = 'Placeholder Category';
                this.js = 'Placeholder';
            }
        }
    },

    watch: {
        selectedJunePage: function () {
            this.getEntityProperties();
        }
    },
});
