const { Component, Mixin } = Shopware;
import template from './list.twig';
import './token-list.scss';

const Criteria = Shopware.Data.Criteria;

Component.register('june-token-list', {
    template,

    inject: ['repositoryFactory'],

    data() {
        return {
            collectToken: null,
            total: 0,
            isLoading: true,
        }
    },

    created() {
        this.getList();
    },

    computed: {
        juneFlowActionRepository() {
            return this.repositoryFactory.create('juneflowaction');
        },

        columns() {
            return [
                {
                    property: 'name',
                    dataIndex: 'name',
                    label: 'Name',
                    inlineEdit: 'string'
                },
                {
                    property: 'collect_token',
                    dataIndex: 'collect_token',
                    label: 'Collect Token',
                    primary: true,
                    inlineEdit: 'string'
                }
            ]
        }
    },

    methods: {
        getList() {
            this.isLoading = true;
            const criteria = new Criteria();

            criteria.addSorting(Criteria.sort('createdAt', 'DESC', false));

            return this.juneFlowActionRepository.search(criteria, Shopware.Context.api).then((result) => {
                this.total = result.total;
                this.collectToken = result;
                this.isLoading = false;
            })
        }
    }
});
